package com.alibaba.ailabs.genie.assistant.demo;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;

import com.alibaba.ailabs.genie.assistant.sdk.gesture.GestureClient;
import com.alibaba.ailabs.genie.assistant.sdk.gesture.OnGestureListener;

import java.util.HashMap;
import java.util.Map;


/**
 * 手势控制:
 * https://aligenie.com/doc/20255408/zbyymp
 */
public class MmiActivity extends BaseActivity implements View.OnClickListener {
    private static final String TAG = "MmiActivity";

    private Map<Integer, String> tips = new HashMap<>();

    private Button mGestureButton;
    private GestureClient mGestureClient;
    private boolean mIsGestureStarted = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_mmi);
        setTitle("手势控制");
        setBackBtn();

        mGestureButton = (Button) findViewById(R.id.gesture_demo);
        mGestureButton.setOnClickListener(this);
        mGestureClient = new GestureClient(this);

    }

    private OnGestureListener mOnGestureListener = new OnGestureListener() {
        @Override
        public void onGesture(int i) {
            Log.e(TAG, "onGesture: " + i);
        }
    };


    @Override
    public void onClick(View v) {
        int id = v.getId();
        if(id == R.id.gesture_demo){
            mIsGestureStarted = !mIsGestureStarted;
            if(mIsGestureStarted){
                mGestureButton.setText("关闭手势");
                tips.put(OnGestureListener.TIPS_PREVIOUS, "上一个");
                tips.put(OnGestureListener.TIPS_NEXT, "下一个");
                tips.put(OnGestureListener.TIPS_PLAY, "播放");
                tips.put(OnGestureListener.TIPS_PAUSE, "暂停");
                tips.put(OnGestureListener.TIPS_BACK, "后退");
                tips.put(OnGestureListener.TIPS_GOOD, "赞");
                mGestureClient.start(OnGestureListener.TIPS_PREVIOUS |
                        OnGestureListener.TIPS_NEXT |
                        OnGestureListener.TIPS_PLAY |
                        OnGestureListener.TIPS_PAUSE |
                        OnGestureListener.TIPS_BACK |
                        OnGestureListener.TIPS_GOOD, tips, mOnGestureListener);
            } else {
                mGestureButton.setText("打开手势");
                mGestureClient.stop();
            }
        }
    }
}