package com.alibaba.ailabs.genie.assistant.demo.userInfo;

import android.graphics.Color;
import android.os.Bundle;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.style.ForegroundColorSpan;
import android.util.Log;
import android.widget.TextView;

import com.alibaba.ailabs.genie.assistant.demo.BaseActivity;
import com.alibaba.ailabs.genie.assistant.demo.R;
import com.alibaba.ailabs.genie.assistant.sdk.account.UserInfoManager;
import com.alibaba.ailabs.genie.assistant.sdk.agis.IResponseCallback;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;

import java.util.Map;

/**
 * 用户信息:
 * https://aligenie.com/doc/20255408/pbibmp
 */
public class UserInfoActivity extends BaseActivity {
    private TextView userInfoText;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.user_info_activity);
        setTitle("用户信息");
        setBackBtn();
        userInfoText = findViewById(R.id.user_info_text);

        // 获取用户信息(注意参数顺序不可改变 否则 在消息推送，应用唤起，日程提醒，获取手机号等能力的时候会出错)
        // @param idType 需要获取的id类型，USER_ID或者DEVICE_ID
        // @param encodeKey 获取ID时，编码类型对应的键值
        //- 如果编码类型为PACKAGE_NAME，则填写具体的包名
        //- 如果编码类型为SKILL_ID，则填写技能的skillid值
        //- 如果编码类型为MINIAPP_ID，则填写小程序的应用id值
        // @param encodeType 获取ID时的编码类型：
        //- 如果应用是APK，则填写PACKAGE_NAME
        //- 如果应用是语音技能，则填写SKILL_ID
        //- 如果应用是小程序，则填写MINIAPP_ID
        // @param callback 结果回调监听器
        // @return 成功或失败
        UserInfoManager.getInstance(this).getIdentifciationID(
                "USER_ID",
                "com.alibaba.ailabs.genie.assistant.demo",
                "PACKAGE_NAME",
                new IResponseCallback() {
                    @Override
                    public void onResponseCallback(int seesionId, int code, String data) {
                        // 获取用户信息
                        Log.e("AccountManager", "mResult: " + data);
                        Map maps = (Map) JSON.parse(data);
                        runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                for (Object map : maps.entrySet()){
                                    String Value = ((Map.Entry)map).getValue().toString();
                                    if (Value.contains("[")) {
                                        userInfoText.append(((Map.Entry)map).getKey() + ":  [ { " + "\n");
                                        JSONArray array = (JSONArray) ((Map.Entry)map).getValue();
                                        for(int i = 0; i < array.size(); i++){
                                            if (i != 0) {
                                                userInfoText.append("{" + "\n");
                                            }
                                            Map item = (Map) JSON.parse(array.get(i).toString());
                                            for (Object map1 : item.entrySet()){
                                                if (((Map.Entry)map1).getValue().toString().contains("{")) {
                                                    userInfoText.append("\t\t\t" + ((Map.Entry)map1).getKey() + ":  {" + "\n");
                                                    Map item1 = (Map) JSON.parse(((Map.Entry)map1).getValue().toString());
                                                    for (Object map2 : item1.entrySet()){
                                                        userInfoText.append("\t\t\t\t\t\t" + ((Map.Entry)map2).getKey() + ":  " + ((Map.Entry)map2).getValue() + "\n");
                                                    }
                                                    userInfoText.append("\t\t\t" + "}" + "\n");
                                                    for (Object map2 : item1.entrySet()){
                                                        String content = userInfoText.getText().toString();
                                                        SpannableString ss = new SpannableString(content);
                                                        ss.setSpan(new ForegroundColorSpan(Color.parseColor("#ff0000")), content.indexOf(((Map.Entry)map2).getKey().toString()), content.indexOf("}"), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
                                                        userInfoText.setText(ss);
                                                    }
                                                } else {
                                                    userInfoText.append("\t\t\t" + ((Map.Entry)map1).getKey() + ":  " + ((Map.Entry)map1).getValue() + "\n");
                                                }
                                            }
                                            if (array.size() - 1 == i) {
                                                userInfoText.append("} ]" + "\n");
                                            } else {
                                                userInfoText.append("}, " + "\n");
                                            }
                                        }
                                    }
                                }
                            }
                        });
                    }
                });
    }
}
